var express = require('express');
var router = express.Router();
var jsonfile = require('jsonfile')
var fs = require('fs')

var multer = require('multer')
var upload = multer({dest: 'uploads'})

/* GET home page. */
router.get('/', function(req, res) {
  var data = new Date().toISOString().substring(0,19)
  jsonfile.readFile(__dirname + '/../data/dbFiles.json', (erro, registos) => {
    if(erro){
      res.render('error', {error: erro})
    }
    else{
      res.render('index', { files: registos, d: data });
    }
  })
});

router.get('/files/upload', function(req, res) {
  var data = new Date().toISOString().substring(0,19)
  res.render('fileForm', {d: data})
});

router.get('/download/:fname', function(req, res) {
  res.download(__dirname + '/../public/fileStore/' + req.params.fname)
});

router.post('/files', upload.single('myFile'), (req, res) => {
  console.log('cdir: ' + __dirname)
  let oldPath = __dirname + '/../' + req.file.path
  console.log('old:' + oldPath)
  let newPath = __dirname + '/../public/fileStore/' + req.file.originalname
  console.log('new:' + newPath)

  fs.rename(oldPath, newPath, erro => {
    if(erro){
      res.render('error', {error: erro})
    }
    else{
      var files = jsonfile.readFileSync(__dirname + '/../data/dbFiles.json')

      files.push({
        date: new Date().toISOString().substring(0,19),
        name: req.file.originalname,
        mimetype: req.file.mimetype,
        size: req.file.size,
        desc: req.body.desc
      })

      jsonfile.writeFileSync(__dirname + '/../data/dbFiles.json', files)
      res.redirect('/')
    }
  })
})

module.exports = router;
